// ==============================================================
// RTL generated by Vivado(TM) HLS - High-Level Synthesis from C, C++ and SystemC
// Version: 2018.3
// Copyright (C) 1986-2018 Xilinx, Inc. All Rights Reserved.
// 
// ===========================================================

#ifndef _RGB2yfb_HH_
#define _RGB2yfb_HH_

#include "systemc.h"
#include "AESL_pkg.h"

#include "RGB2yfb_mul_29ns_11ns_40_3_1.h"
#include "RGB2yfb_urem_17ns_9ns_17_21_1.h"
#include "RGB2yfb_mac_muladd_8ns_8ns_16ns_16_1_1.h"
#include "RGB2yfb_mac_muladd_6ns_8ns_16ns_16_1_1.h"
#include "RGB2yfb_AXILiteS_s_axi.h"
#include "RGB2yfb_gmem_m_axi.h"

namespace ap_rtl {

template<unsigned int C_M_AXI_GMEM_ADDR_WIDTH = 32,
         unsigned int C_M_AXI_GMEM_ID_WIDTH = 1,
         unsigned int C_M_AXI_GMEM_AWUSER_WIDTH = 1,
         unsigned int C_M_AXI_GMEM_DATA_WIDTH = 64,
         unsigned int C_M_AXI_GMEM_WUSER_WIDTH = 1,
         unsigned int C_M_AXI_GMEM_ARUSER_WIDTH = 1,
         unsigned int C_M_AXI_GMEM_RUSER_WIDTH = 1,
         unsigned int C_M_AXI_GMEM_BUSER_WIDTH = 1,
         unsigned int C_S_AXI_AXILITES_ADDR_WIDTH = 6,
         unsigned int C_S_AXI_AXILITES_DATA_WIDTH = 32>
struct RGB2yfb : public sc_module {
    // Port declarations 74
    sc_in_clk ap_clk;
    sc_in< sc_logic > ap_rst_n;
    sc_out< sc_logic > m_axi_gmem_AWVALID;
    sc_in< sc_logic > m_axi_gmem_AWREADY;
    sc_out< sc_uint<C_M_AXI_GMEM_ADDR_WIDTH> > m_axi_gmem_AWADDR;
    sc_out< sc_uint<C_M_AXI_GMEM_ID_WIDTH> > m_axi_gmem_AWID;
    sc_out< sc_lv<8> > m_axi_gmem_AWLEN;
    sc_out< sc_lv<3> > m_axi_gmem_AWSIZE;
    sc_out< sc_lv<2> > m_axi_gmem_AWBURST;
    sc_out< sc_lv<2> > m_axi_gmem_AWLOCK;
    sc_out< sc_lv<4> > m_axi_gmem_AWCACHE;
    sc_out< sc_lv<3> > m_axi_gmem_AWPROT;
    sc_out< sc_lv<4> > m_axi_gmem_AWQOS;
    sc_out< sc_lv<4> > m_axi_gmem_AWREGION;
    sc_out< sc_uint<C_M_AXI_GMEM_AWUSER_WIDTH> > m_axi_gmem_AWUSER;
    sc_out< sc_logic > m_axi_gmem_WVALID;
    sc_in< sc_logic > m_axi_gmem_WREADY;
    sc_out< sc_uint<C_M_AXI_GMEM_DATA_WIDTH> > m_axi_gmem_WDATA;
    sc_out< sc_uint<C_M_AXI_GMEM_DATA_WIDTH/8> > m_axi_gmem_WSTRB;
    sc_out< sc_logic > m_axi_gmem_WLAST;
    sc_out< sc_uint<C_M_AXI_GMEM_ID_WIDTH> > m_axi_gmem_WID;
    sc_out< sc_uint<C_M_AXI_GMEM_WUSER_WIDTH> > m_axi_gmem_WUSER;
    sc_out< sc_logic > m_axi_gmem_ARVALID;
    sc_in< sc_logic > m_axi_gmem_ARREADY;
    sc_out< sc_uint<C_M_AXI_GMEM_ADDR_WIDTH> > m_axi_gmem_ARADDR;
    sc_out< sc_uint<C_M_AXI_GMEM_ID_WIDTH> > m_axi_gmem_ARID;
    sc_out< sc_lv<8> > m_axi_gmem_ARLEN;
    sc_out< sc_lv<3> > m_axi_gmem_ARSIZE;
    sc_out< sc_lv<2> > m_axi_gmem_ARBURST;
    sc_out< sc_lv<2> > m_axi_gmem_ARLOCK;
    sc_out< sc_lv<4> > m_axi_gmem_ARCACHE;
    sc_out< sc_lv<3> > m_axi_gmem_ARPROT;
    sc_out< sc_lv<4> > m_axi_gmem_ARQOS;
    sc_out< sc_lv<4> > m_axi_gmem_ARREGION;
    sc_out< sc_uint<C_M_AXI_GMEM_ARUSER_WIDTH> > m_axi_gmem_ARUSER;
    sc_in< sc_logic > m_axi_gmem_RVALID;
    sc_out< sc_logic > m_axi_gmem_RREADY;
    sc_in< sc_uint<C_M_AXI_GMEM_DATA_WIDTH> > m_axi_gmem_RDATA;
    sc_in< sc_logic > m_axi_gmem_RLAST;
    sc_in< sc_uint<C_M_AXI_GMEM_ID_WIDTH> > m_axi_gmem_RID;
    sc_in< sc_uint<C_M_AXI_GMEM_RUSER_WIDTH> > m_axi_gmem_RUSER;
    sc_in< sc_lv<2> > m_axi_gmem_RRESP;
    sc_in< sc_logic > m_axi_gmem_BVALID;
    sc_out< sc_logic > m_axi_gmem_BREADY;
    sc_in< sc_lv<2> > m_axi_gmem_BRESP;
    sc_in< sc_uint<C_M_AXI_GMEM_ID_WIDTH> > m_axi_gmem_BID;
    sc_in< sc_uint<C_M_AXI_GMEM_BUSER_WIDTH> > m_axi_gmem_BUSER;
    sc_in< sc_lv<24> > video_in_TDATA;
    sc_in< sc_logic > video_in_TVALID;
    sc_out< sc_logic > video_in_TREADY;
    sc_in< sc_lv<3> > video_in_TKEEP;
    sc_in< sc_lv<3> > video_in_TSTRB;
    sc_in< sc_lv<1> > video_in_TUSER;
    sc_in< sc_lv<1> > video_in_TLAST;
    sc_in< sc_lv<1> > video_in_TID;
    sc_in< sc_lv<1> > video_in_TDEST;
    sc_in< sc_logic > s_axi_AXILiteS_AWVALID;
    sc_out< sc_logic > s_axi_AXILiteS_AWREADY;
    sc_in< sc_uint<C_S_AXI_AXILITES_ADDR_WIDTH> > s_axi_AXILiteS_AWADDR;
    sc_in< sc_logic > s_axi_AXILiteS_WVALID;
    sc_out< sc_logic > s_axi_AXILiteS_WREADY;
    sc_in< sc_uint<C_S_AXI_AXILITES_DATA_WIDTH> > s_axi_AXILiteS_WDATA;
    sc_in< sc_uint<C_S_AXI_AXILITES_DATA_WIDTH/8> > s_axi_AXILiteS_WSTRB;
    sc_in< sc_logic > s_axi_AXILiteS_ARVALID;
    sc_out< sc_logic > s_axi_AXILiteS_ARREADY;
    sc_in< sc_uint<C_S_AXI_AXILITES_ADDR_WIDTH> > s_axi_AXILiteS_ARADDR;
    sc_out< sc_logic > s_axi_AXILiteS_RVALID;
    sc_in< sc_logic > s_axi_AXILiteS_RREADY;
    sc_out< sc_uint<C_S_AXI_AXILITES_DATA_WIDTH> > s_axi_AXILiteS_RDATA;
    sc_out< sc_lv<2> > s_axi_AXILiteS_RRESP;
    sc_out< sc_logic > s_axi_AXILiteS_BVALID;
    sc_in< sc_logic > s_axi_AXILiteS_BREADY;
    sc_out< sc_lv<2> > s_axi_AXILiteS_BRESP;
    sc_out< sc_logic > interrupt;
    sc_signal< sc_logic > ap_var_for_const0;
    sc_signal< sc_logic > ap_var_for_const2;
    sc_signal< sc_lv<32> > ap_var_for_const1;
    sc_signal< sc_lv<1> > ap_var_for_const3;
    sc_signal< sc_lv<2> > ap_var_for_const5;
    sc_signal< sc_lv<32> > ap_var_for_const7;
    sc_signal< sc_lv<3> > ap_var_for_const4;
    sc_signal< sc_lv<4> > ap_var_for_const6;
    sc_signal< sc_lv<8> > ap_var_for_const8;


    // Module declarations
    RGB2yfb(sc_module_name name);
    SC_HAS_PROCESS(RGB2yfb);

    ~RGB2yfb();

    sc_trace_file* mVcdFile;

    ofstream mHdltvinHandle;
    ofstream mHdltvoutHandle;
    RGB2yfb_AXILiteS_s_axi<C_S_AXI_AXILITES_ADDR_WIDTH,C_S_AXI_AXILITES_DATA_WIDTH>* RGB2yfb_AXILiteS_s_axi_U;
    RGB2yfb_gmem_m_axi<0,64,32,5,16,16,16,16,C_M_AXI_GMEM_ID_WIDTH,C_M_AXI_GMEM_ADDR_WIDTH,C_M_AXI_GMEM_DATA_WIDTH,C_M_AXI_GMEM_AWUSER_WIDTH,C_M_AXI_GMEM_ARUSER_WIDTH,C_M_AXI_GMEM_WUSER_WIDTH,C_M_AXI_GMEM_RUSER_WIDTH,C_M_AXI_GMEM_BUSER_WIDTH,C_M_AXI_GMEM_USER_VALUE,C_M_AXI_GMEM_PROT_VALUE,C_M_AXI_GMEM_CACHE_VALUE>* RGB2yfb_gmem_m_axi_U;
    RGB2yfb_mul_29ns_11ns_40_3_1<1,3,29,11,40>* RGB2yfb_mul_29ns_11ns_40_3_1_U1;
    RGB2yfb_urem_17ns_9ns_17_21_1<1,21,17,9,17>* RGB2yfb_urem_17ns_9ns_17_21_1_U2;
    RGB2yfb_urem_17ns_9ns_17_21_1<1,21,17,9,17>* RGB2yfb_urem_17ns_9ns_17_21_1_U3;
    RGB2yfb_mac_muladd_8ns_8ns_16ns_16_1_1<1,1,8,8,16,16>* RGB2yfb_mac_muladd_8ns_8ns_16ns_16_1_1_U4;
    RGB2yfb_mac_muladd_6ns_8ns_16ns_16_1_1<1,1,6,8,16,16>* RGB2yfb_mac_muladd_6ns_8ns_16ns_16_1_1_U5;
    RGB2yfb_mac_muladd_8ns_8ns_16ns_16_1_1<1,1,8,8,16,16>* RGB2yfb_mac_muladd_8ns_8ns_16ns_16_1_1_U6;
    RGB2yfb_mac_muladd_6ns_8ns_16ns_16_1_1<1,1,6,8,16,16>* RGB2yfb_mac_muladd_6ns_8ns_16ns_16_1_1_U7;
    RGB2yfb_mac_muladd_8ns_8ns_16ns_16_1_1<1,1,8,8,16,16>* RGB2yfb_mac_muladd_8ns_8ns_16ns_16_1_1_U8;
    RGB2yfb_mac_muladd_6ns_8ns_16ns_16_1_1<1,1,6,8,16,16>* RGB2yfb_mac_muladd_6ns_8ns_16ns_16_1_1_U9;
    RGB2yfb_mac_muladd_8ns_8ns_16ns_16_1_1<1,1,8,8,16,16>* RGB2yfb_mac_muladd_8ns_8ns_16ns_16_1_1_U10;
    RGB2yfb_mac_muladd_6ns_8ns_16ns_16_1_1<1,1,6,8,16,16>* RGB2yfb_mac_muladd_6ns_8ns_16ns_16_1_1_U11;
    RGB2yfb_mac_muladd_8ns_8ns_16ns_16_1_1<1,1,8,8,16,16>* RGB2yfb_mac_muladd_8ns_8ns_16ns_16_1_1_U12;
    RGB2yfb_mac_muladd_6ns_8ns_16ns_16_1_1<1,1,6,8,16,16>* RGB2yfb_mac_muladd_6ns_8ns_16ns_16_1_1_U13;
    RGB2yfb_mac_muladd_8ns_8ns_16ns_16_1_1<1,1,8,8,16,16>* RGB2yfb_mac_muladd_8ns_8ns_16ns_16_1_1_U14;
    RGB2yfb_mac_muladd_6ns_8ns_16ns_16_1_1<1,1,6,8,16,16>* RGB2yfb_mac_muladd_6ns_8ns_16ns_16_1_1_U15;
    RGB2yfb_mac_muladd_8ns_8ns_16ns_16_1_1<1,1,8,8,16,16>* RGB2yfb_mac_muladd_8ns_8ns_16ns_16_1_1_U16;
    RGB2yfb_mac_muladd_6ns_8ns_16ns_16_1_1<1,1,6,8,16,16>* RGB2yfb_mac_muladd_6ns_8ns_16ns_16_1_1_U17;
    RGB2yfb_mac_muladd_8ns_8ns_16ns_16_1_1<1,1,8,8,16,16>* RGB2yfb_mac_muladd_8ns_8ns_16ns_16_1_1_U18;
    RGB2yfb_mac_muladd_6ns_8ns_16ns_16_1_1<1,1,6,8,16,16>* RGB2yfb_mac_muladd_6ns_8ns_16ns_16_1_1_U19;
    sc_signal< sc_logic > ap_rst_n_inv;
    sc_signal< sc_logic > ap_start;
    sc_signal< sc_logic > ap_done;
    sc_signal< sc_logic > ap_idle;
    sc_signal< sc_lv<16> > ap_CS_fsm;
    sc_signal< sc_logic > ap_CS_fsm_state1;
    sc_signal< sc_logic > ap_ready;
    sc_signal< sc_lv<32> > fb_out;
    sc_signal< sc_lv<32> > hsize;
    sc_signal< sc_lv<32> > vsize;
    sc_signal< sc_lv<32> > stride;
    sc_signal< sc_lv<32> > fsize;
    sc_signal< sc_logic > gmem_blk_n_AW;
    sc_signal< sc_logic > ap_CS_fsm_pp0_stage5;
    sc_signal< sc_logic > ap_enable_reg_pp0_iter2;
    sc_signal< bool > ap_block_pp0_stage5;
    sc_signal< sc_lv<1> > tmp_25_reg_1119;
    sc_signal< sc_logic > gmem_blk_n_W;
    sc_signal< sc_logic > ap_CS_fsm_pp0_stage6;
    sc_signal< bool > ap_block_pp0_stage6;
    sc_signal< sc_lv<1> > exitcond_flatten_reg_923;
    sc_signal< sc_lv<1> > exitcond_flatten_reg_923_pp0_iter2_reg;
    sc_signal< sc_logic > gmem_blk_n_B;
    sc_signal< sc_logic > ap_CS_fsm_pp0_stage3;
    sc_signal< sc_logic > ap_enable_reg_pp0_iter3;
    sc_signal< bool > ap_block_pp0_stage3;
    sc_signal< sc_lv<1> > tmp_27_reg_1134;
    sc_signal< sc_logic > video_in_TDATA_blk_n;
    sc_signal< sc_logic > ap_CS_fsm_state7;
    sc_signal< sc_lv<1> > tmp_1_nbreadreq_fu_160_p9;
    sc_signal< sc_logic > ap_CS_fsm_pp0_stage1;
    sc_signal< sc_logic > ap_enable_reg_pp0_iter0;
    sc_signal< bool > ap_block_pp0_stage1;
    sc_signal< sc_logic > ap_CS_fsm_pp0_stage2;
    sc_signal< bool > ap_block_pp0_stage2;
    sc_signal< sc_logic > ap_CS_fsm_pp0_stage4;
    sc_signal< bool > ap_block_pp0_stage4;
    sc_signal< sc_logic > ap_CS_fsm_pp0_stage7;
    sc_signal< bool > ap_block_pp0_stage7;
    sc_signal< sc_logic > ap_CS_fsm_pp0_stage0;
    sc_signal< bool > ap_block_pp0_stage0;
    sc_signal< sc_lv<1> > exitcond_flatten_fu_383_p2;
    sc_signal< sc_lv<1> > ap_phi_mux_is_first_line_1_phi_fu_273_p4;
    sc_signal< sc_logic > gmem_AWVALID;
    sc_signal< sc_logic > gmem_AWREADY;
    sc_signal< sc_lv<32> > gmem_AWADDR;
    sc_signal< sc_logic > gmem_WVALID;
    sc_signal< sc_logic > gmem_WREADY;
    sc_signal< sc_logic > gmem_ARREADY;
    sc_signal< sc_logic > gmem_RVALID;
    sc_signal< sc_lv<64> > gmem_RDATA;
    sc_signal< sc_logic > gmem_RLAST;
    sc_signal< sc_lv<1> > gmem_RID;
    sc_signal< sc_lv<1> > gmem_RUSER;
    sc_signal< sc_lv<2> > gmem_RRESP;
    sc_signal< sc_logic > gmem_BVALID;
    sc_signal< sc_logic > gmem_BREADY;
    sc_signal< sc_lv<2> > gmem_BRESP;
    sc_signal< sc_lv<1> > gmem_BID;
    sc_signal< sc_lv<1> > gmem_BUSER;
    sc_signal< sc_lv<17> > indvar_flatten_reg_237;
    sc_signal< bool > ap_predicate_op99_read_state8;
    sc_signal< bool > ap_block_state8_pp0_stage0_iter0;
    sc_signal< bool > ap_block_state16_pp0_stage0_iter1;
    sc_signal< bool > ap_block_state24_pp0_stage0_iter2;
    sc_signal< bool > ap_block_state32_pp0_stage0_iter3;
    sc_signal< bool > ap_block_pp0_stage0_11001;
    sc_signal< sc_lv<39> > p_1_rec_reg_249;
    sc_signal< sc_lv<24> > pix_0_1_reg_260;
    sc_signal< sc_lv<1> > is_first_line_1_reg_269;
    sc_signal< sc_lv<8> > blk_idx_reg_282;
    sc_signal< sc_lv<8> > reg_328;
    sc_signal< bool > ap_block_state9_pp0_stage1_iter0;
    sc_signal< bool > ap_block_state17_pp0_stage1_iter1;
    sc_signal< bool > ap_block_state25_pp0_stage1_iter2;
    sc_signal< bool > ap_block_state33_pp0_stage1_iter3;
    sc_signal< bool > ap_block_pp0_stage1_11001;
    sc_signal< bool > ap_block_state10_pp0_stage2_iter0;
    sc_signal< bool > ap_block_state18_pp0_stage2_iter1;
    sc_signal< bool > ap_block_state26_pp0_stage2_iter2;
    sc_signal< bool > ap_block_state34_pp0_stage2_iter3;
    sc_signal< bool > ap_block_pp0_stage2_11001;
    sc_signal< bool > ap_block_state11_pp0_stage3_iter0;
    sc_signal< bool > ap_block_state19_pp0_stage3_iter1;
    sc_signal< bool > ap_block_state27_pp0_stage3_iter2;
    sc_signal< bool > ap_block_state35_pp0_stage3_iter3;
    sc_signal< bool > ap_block_pp0_stage3_11001;
    sc_signal< bool > ap_block_state12_pp0_stage4_iter0;
    sc_signal< bool > ap_block_state20_pp0_stage4_iter1;
    sc_signal< bool > ap_block_state28_pp0_stage4_iter2;
    sc_signal< bool > ap_block_pp0_stage4_11001;
    sc_signal< bool > ap_block_state13_pp0_stage5_iter0;
    sc_signal< bool > ap_block_state21_pp0_stage5_iter1;
    sc_signal< bool > ap_block_state29_pp0_stage5_iter2;
    sc_signal< sc_logic > ap_sig_ioackin_gmem_AWREADY;
    sc_signal< bool > ap_block_state29_io;
    sc_signal< bool > ap_block_pp0_stage5_11001;
    sc_signal< bool > ap_block_state14_pp0_stage6_iter0;
    sc_signal< bool > ap_block_state22_pp0_stage6_iter1;
    sc_signal< bool > ap_block_state30_pp0_stage6_iter2;
    sc_signal< sc_logic > ap_sig_ioackin_gmem_WREADY;
    sc_signal< bool > ap_block_state30_io;
    sc_signal< bool > ap_block_pp0_stage6_11001;
    sc_signal< bool > ap_block_state15_pp0_stage7_iter0;
    sc_signal< bool > ap_block_state23_pp0_stage7_iter1;
    sc_signal< bool > ap_block_state31_pp0_stage7_iter2;
    sc_signal< bool > ap_block_pp0_stage7_11001;
    sc_signal< sc_lv<29> > tmp_3_reg_871;
    sc_signal< sc_lv<29> > tmp_reg_876;
    sc_signal< sc_logic > ap_CS_fsm_state2;
    sc_signal< sc_lv<40> > tmp_3_cast_fu_361_p1;
    sc_signal< sc_lv<40> > tmp_3_cast_reg_887;
    sc_signal< sc_logic > ap_CS_fsm_state4;
    sc_signal< sc_lv<39> > tmp_1_cast1_fu_364_p1;
    sc_signal< sc_lv<39> > tmp_1_cast1_reg_892;
    sc_signal< sc_lv<40> > grp_fu_355_p2;
    sc_signal< sc_lv<40> > tmp_2_reg_897;
    sc_signal< sc_lv<2> > i_1_fu_373_p2;
    sc_signal< sc_lv<2> > i_1_reg_905;
    sc_signal< sc_logic > ap_CS_fsm_state5;
    sc_signal< bool > ap_block_state7;
    sc_signal< sc_lv<1> > tmp_user_V_fu_379_p1;
    sc_signal< sc_lv<1> > exitcond_flatten_reg_923_pp0_iter1_reg;
    sc_signal< sc_lv<17> > indvar_flatten_next_fu_389_p2;
    sc_signal< sc_lv<17> > indvar_flatten_next_reg_927;
    sc_signal< sc_lv<39> > tmp_15_mid2_v_v_v_fu_406_p3;
    sc_signal< sc_lv<39> > tmp_15_mid2_v_v_v_reg_933;
    sc_signal< sc_lv<8> > tmp_16_fu_414_p1;
    sc_signal< sc_lv<8> > tmp_16_reg_939;
    sc_signal< sc_lv<8> > tmp_4_reg_944;
    sc_signal< sc_lv<16> > tmp_8_fu_442_p2;
    sc_signal< sc_lv<16> > tmp_8_reg_949;
    sc_signal< sc_lv<8> > blk_idx_1_fu_460_p3;
    sc_signal< sc_lv<8> > blk_idx_1_reg_954;
    sc_signal< sc_lv<16> > grp_fu_751_p3;
    sc_signal< sc_lv<16> > tmp1_reg_959;
    sc_signal< sc_lv<8> > tmp_17_fu_471_p1;
    sc_signal< sc_lv<8> > tmp_17_reg_964;
    sc_signal< sc_lv<16> > tmp_8_1_fu_479_p2;
    sc_signal< sc_lv<16> > tmp_8_1_reg_969;
    sc_signal< sc_lv<8> > y1_reg_974;
    sc_signal< sc_lv<8> > y1_reg_974_pp0_iter1_reg;
    sc_signal< sc_lv<8> > y1_reg_974_pp0_iter2_reg;
    sc_signal< sc_lv<16> > grp_fu_766_p3;
    sc_signal< sc_lv<16> > tmp2_reg_979;
    sc_signal< sc_lv<8> > tmp_18_fu_506_p1;
    sc_signal< sc_lv<8> > tmp_18_reg_984;
    sc_signal< sc_lv<16> > tmp_8_2_fu_514_p2;
    sc_signal< sc_lv<16> > tmp_8_2_reg_989;
    sc_signal< sc_lv<8> > y1_1_reg_994;
    sc_signal< sc_lv<8> > y1_1_reg_994_pp0_iter1_reg;
    sc_signal< sc_lv<8> > y1_1_reg_994_pp0_iter2_reg;
    sc_signal< sc_lv<16> > grp_fu_781_p3;
    sc_signal< sc_lv<16> > tmp3_reg_999;
    sc_signal< sc_lv<8> > tmp_19_fu_536_p1;
    sc_signal< sc_lv<8> > tmp_19_reg_1004;
    sc_signal< sc_lv<16> > tmp_8_3_fu_544_p2;
    sc_signal< sc_lv<16> > tmp_8_3_reg_1009;
    sc_signal< sc_lv<8> > y1_2_reg_1014;
    sc_signal< sc_lv<8> > y1_2_reg_1014_pp0_iter1_reg;
    sc_signal< sc_lv<8> > y1_2_reg_1014_pp0_iter2_reg;
    sc_signal< sc_lv<16> > grp_fu_796_p3;
    sc_signal< sc_lv<16> > tmp4_reg_1019;
    sc_signal< sc_lv<8> > tmp_20_fu_566_p1;
    sc_signal< sc_lv<8> > tmp_20_reg_1024;
    sc_signal< sc_lv<16> > tmp_8_4_fu_574_p2;
    sc_signal< sc_lv<16> > tmp_8_4_reg_1029;
    sc_signal< sc_lv<8> > y1_3_reg_1034;
    sc_signal< sc_lv<8> > y1_3_reg_1034_pp0_iter1_reg;
    sc_signal< sc_lv<16> > grp_fu_811_p3;
    sc_signal< sc_lv<16> > tmp5_reg_1039;
    sc_signal< sc_lv<8> > tmp_21_fu_596_p1;
    sc_signal< sc_lv<8> > tmp_21_reg_1044;
    sc_signal< sc_lv<16> > tmp_8_5_fu_604_p2;
    sc_signal< sc_lv<16> > tmp_8_5_reg_1049;
    sc_signal< sc_lv<8> > y1_4_reg_1054;
    sc_signal< sc_lv<8> > y1_4_reg_1054_pp0_iter1_reg;
    sc_signal< sc_lv<16> > grp_fu_826_p3;
    sc_signal< sc_lv<16> > tmp6_reg_1059;
    sc_signal< sc_lv<8> > tmp_22_fu_626_p1;
    sc_signal< sc_lv<8> > tmp_22_reg_1064;
    sc_signal< sc_lv<16> > tmp_8_6_fu_634_p2;
    sc_signal< sc_lv<16> > tmp_8_6_reg_1069;
    sc_signal< sc_lv<8> > y1_5_reg_1074;
    sc_signal< sc_lv<8> > y1_5_reg_1074_pp0_iter1_reg;
    sc_signal< sc_lv<16> > grp_fu_841_p3;
    sc_signal< sc_lv<16> > tmp7_reg_1079;
    sc_signal< sc_lv<24> > tmp_data_V_7_reg_1084;
    sc_signal< sc_lv<8> > tmp_23_fu_656_p1;
    sc_signal< sc_lv<8> > tmp_23_reg_1089;
    sc_signal< sc_lv<16> > tmp_8_7_fu_664_p2;
    sc_signal< sc_lv<16> > tmp_8_7_reg_1094;
    sc_signal< sc_lv<8> > y1_6_reg_1099;
    sc_signal< sc_lv<8> > y1_6_reg_1099_pp0_iter2_reg;
    sc_signal< sc_lv<16> > grp_fu_856_p3;
    sc_signal< sc_lv<16> > tmp8_reg_1104;
    sc_signal< sc_logic > ap_enable_reg_pp0_iter1;
    sc_signal< sc_lv<40> > fb_out2_sum3_fu_695_p2;
    sc_signal< sc_lv<40> > fb_out2_sum3_reg_1109;
    sc_signal< sc_lv<40> > fb_out2_sum3_reg_1109_pp0_iter2_reg;
    sc_signal< sc_lv<8> > y1_7_reg_1114;
    sc_signal< sc_lv<8> > y1_7_reg_1114_pp0_iter2_reg;
    sc_signal< sc_lv<1> > tmp_25_fu_712_p2;
    sc_signal< sc_lv<64> > blk_7_fu_718_p9;
    sc_signal< sc_lv<64> > blk_7_reg_1123;
    sc_signal< sc_lv<1> > tmp_27_fu_740_p2;
    sc_signal< sc_lv<40> > p_1_rec1_fu_746_p2;
    sc_signal< sc_logic > ap_CS_fsm_state36;
    sc_signal< bool > ap_block_pp0_stage0_subdone;
    sc_signal< sc_logic > ap_condition_pp0_exit_iter0_state8;
    sc_signal< bool > ap_block_pp0_stage7_subdone;
    sc_signal< bool > ap_block_pp0_stage3_subdone;
    sc_signal< sc_lv<40> > p_09_rec_reg_214;
    sc_signal< sc_lv<2> > i_reg_226;
    sc_signal< sc_lv<17> > ap_phi_mux_indvar_flatten_phi_fu_241_p4;
    sc_signal< sc_lv<39> > ap_phi_mux_p_1_rec_phi_fu_253_p4;
    sc_signal< sc_lv<24> > ap_phi_mux_pix_0_1_phi_fu_263_p4;
    sc_signal< sc_lv<8> > ap_phi_mux_blk_idx_phi_fu_286_p4;
    sc_signal< sc_lv<24> > ap_phi_mux_pix_0_3_phi_fu_296_p4;
    sc_signal< sc_lv<24> > ap_phi_reg_pp0_iter0_pix_0_3_reg_293;
    sc_signal< sc_lv<64> > fb_out2_sum3_cast_fu_730_p1;
    sc_signal< sc_logic > ap_reg_ioackin_gmem_AWREADY;
    sc_signal< bool > ap_block_pp0_stage5_01001;
    sc_signal< sc_logic > ap_reg_ioackin_gmem_WREADY;
    sc_signal< bool > ap_block_pp0_stage6_01001;
    sc_signal< sc_lv<29> > grp_fu_355_p0;
    sc_signal< sc_lv<11> > grp_fu_355_p1;
    sc_signal< sc_lv<1> > tmp_7_fu_395_p2;
    sc_signal< sc_lv<39> > p_rec_dup4_fu_401_p2;
    sc_signal< sc_lv<8> > tmp_9_cast_fu_418_p4;
    sc_signal< sc_lv<8> > tmp_8_fu_442_p1;
    sc_signal< sc_lv<9> > grp_fu_448_p1;
    sc_signal< sc_lv<8> > blk_idx_op_fu_454_p2;
    sc_signal< sc_lv<8> > grp_fu_308_p4;
    sc_signal< sc_lv<8> > tmp_8_1_fu_479_p1;
    sc_signal< sc_lv<9> > grp_fu_485_p1;
    sc_signal< sc_lv<16> > grp_fu_758_p3;
    sc_signal< sc_lv<8> > tmp_8_2_fu_514_p1;
    sc_signal< sc_lv<16> > grp_fu_773_p3;
    sc_signal< sc_lv<8> > tmp_8_3_fu_544_p1;
    sc_signal< sc_lv<16> > grp_fu_788_p3;
    sc_signal< sc_lv<8> > tmp_8_4_fu_574_p1;
    sc_signal< sc_lv<16> > grp_fu_803_p3;
    sc_signal< sc_lv<8> > tmp_8_5_fu_604_p1;
    sc_signal< sc_lv<16> > grp_fu_818_p3;
    sc_signal< sc_lv<8> > tmp_8_6_fu_634_p1;
    sc_signal< sc_lv<16> > grp_fu_833_p3;
    sc_signal< sc_lv<8> > tmp_8_7_fu_664_p1;
    sc_signal< sc_lv<40> > tmp_15_mid2_v_v_fu_670_p1;
    sc_signal< sc_lv<16> > grp_fu_848_p3;
    sc_signal< sc_lv<40> > tmp_15_mid2_v_fu_673_p2;
    sc_signal< sc_lv<16> > grp_fu_863_p3;
    sc_signal< sc_lv<17> > grp_fu_448_p2;
    sc_signal< sc_lv<17> > grp_fu_485_p2;
    sc_signal< sc_lv<8> > grp_fu_751_p0;
    sc_signal< sc_lv<8> > grp_fu_751_p1;
    sc_signal< sc_lv<6> > grp_fu_758_p0;
    sc_signal< sc_lv<8> > grp_fu_758_p1;
    sc_signal< sc_lv<8> > grp_fu_766_p0;
    sc_signal< sc_lv<8> > grp_fu_766_p1;
    sc_signal< sc_lv<6> > grp_fu_773_p0;
    sc_signal< sc_lv<8> > grp_fu_773_p1;
    sc_signal< sc_lv<8> > grp_fu_781_p0;
    sc_signal< sc_lv<8> > grp_fu_781_p1;
    sc_signal< sc_lv<6> > grp_fu_788_p0;
    sc_signal< sc_lv<8> > grp_fu_788_p1;
    sc_signal< sc_lv<8> > grp_fu_796_p0;
    sc_signal< sc_lv<8> > grp_fu_796_p1;
    sc_signal< sc_lv<6> > grp_fu_803_p0;
    sc_signal< sc_lv<8> > grp_fu_803_p1;
    sc_signal< sc_lv<8> > grp_fu_811_p0;
    sc_signal< sc_lv<8> > grp_fu_811_p1;
    sc_signal< sc_lv<6> > grp_fu_818_p0;
    sc_signal< sc_lv<8> > grp_fu_818_p1;
    sc_signal< sc_lv<8> > grp_fu_826_p0;
    sc_signal< sc_lv<8> > grp_fu_826_p1;
    sc_signal< sc_lv<6> > grp_fu_833_p0;
    sc_signal< sc_lv<8> > grp_fu_833_p1;
    sc_signal< sc_lv<8> > grp_fu_841_p0;
    sc_signal< sc_lv<8> > grp_fu_841_p1;
    sc_signal< sc_lv<6> > grp_fu_848_p0;
    sc_signal< sc_lv<8> > grp_fu_848_p1;
    sc_signal< sc_lv<8> > grp_fu_856_p0;
    sc_signal< sc_lv<8> > grp_fu_856_p1;
    sc_signal< sc_lv<6> > grp_fu_863_p0;
    sc_signal< sc_lv<8> > grp_fu_863_p1;
    sc_signal< sc_lv<1> > exitcond_fu_367_p2;
    sc_signal< sc_logic > grp_fu_448_ce;
    sc_signal< sc_logic > grp_fu_485_ce;
    sc_signal< sc_lv<16> > ap_NS_fsm;
    sc_signal< bool > ap_block_pp0_stage1_subdone;
    sc_signal< bool > ap_block_pp0_stage2_subdone;
    sc_signal< bool > ap_block_pp0_stage4_subdone;
    sc_signal< bool > ap_block_pp0_stage5_subdone;
    sc_signal< bool > ap_block_pp0_stage6_subdone;
    sc_signal< sc_logic > ap_idle_pp0;
    sc_signal< sc_logic > ap_enable_pp0;
    sc_signal< sc_lv<40> > grp_fu_355_p00;
    sc_signal< sc_lv<16> > grp_fu_751_p10;
    sc_signal< sc_lv<14> > grp_fu_758_p10;
    sc_signal< sc_lv<16> > grp_fu_766_p10;
    sc_signal< sc_lv<14> > grp_fu_773_p10;
    sc_signal< sc_lv<16> > grp_fu_781_p10;
    sc_signal< sc_lv<14> > grp_fu_788_p10;
    sc_signal< sc_lv<16> > grp_fu_796_p10;
    sc_signal< sc_lv<14> > grp_fu_803_p10;
    sc_signal< sc_lv<16> > grp_fu_811_p10;
    sc_signal< sc_lv<14> > grp_fu_818_p10;
    sc_signal< sc_lv<16> > grp_fu_826_p10;
    sc_signal< sc_lv<14> > grp_fu_833_p10;
    sc_signal< sc_lv<16> > grp_fu_841_p10;
    sc_signal< sc_lv<14> > grp_fu_848_p10;
    sc_signal< sc_lv<16> > grp_fu_856_p10;
    sc_signal< sc_lv<14> > grp_fu_863_p10;
    sc_signal< sc_lv<16> > tmp_8_1_fu_479_p10;
    sc_signal< sc_lv<16> > tmp_8_2_fu_514_p10;
    sc_signal< sc_lv<16> > tmp_8_3_fu_544_p10;
    sc_signal< sc_lv<16> > tmp_8_4_fu_574_p10;
    sc_signal< sc_lv<16> > tmp_8_5_fu_604_p10;
    sc_signal< sc_lv<16> > tmp_8_6_fu_634_p10;
    sc_signal< sc_lv<16> > tmp_8_7_fu_664_p10;
    sc_signal< sc_lv<16> > tmp_8_fu_442_p10;
    sc_signal< bool > ap_condition_1290;
    sc_signal< bool > ap_condition_1293;
    sc_signal< bool > ap_condition_1297;
    sc_signal< sc_lv<32> > ap_return;
    static const sc_logic ap_const_logic_1;
    static const sc_logic ap_const_logic_0;
    static const sc_lv<16> ap_ST_fsm_state1;
    static const sc_lv<16> ap_ST_fsm_state2;
    static const sc_lv<16> ap_ST_fsm_state3;
    static const sc_lv<16> ap_ST_fsm_state4;
    static const sc_lv<16> ap_ST_fsm_state5;
    static const sc_lv<16> ap_ST_fsm_state6;
    static const sc_lv<16> ap_ST_fsm_state7;
    static const sc_lv<16> ap_ST_fsm_pp0_stage0;
    static const sc_lv<16> ap_ST_fsm_pp0_stage1;
    static const sc_lv<16> ap_ST_fsm_pp0_stage2;
    static const sc_lv<16> ap_ST_fsm_pp0_stage3;
    static const sc_lv<16> ap_ST_fsm_pp0_stage4;
    static const sc_lv<16> ap_ST_fsm_pp0_stage5;
    static const sc_lv<16> ap_ST_fsm_pp0_stage6;
    static const sc_lv<16> ap_ST_fsm_pp0_stage7;
    static const sc_lv<16> ap_ST_fsm_state36;
    static const sc_lv<32> ap_const_lv32_0;
    static const bool ap_const_boolean_1;
    static const sc_lv<32> ap_const_lv32_C;
    static const bool ap_const_boolean_0;
    static const sc_lv<1> ap_const_lv1_1;
    static const sc_lv<32> ap_const_lv32_D;
    static const sc_lv<1> ap_const_lv1_0;
    static const sc_lv<32> ap_const_lv32_A;
    static const sc_lv<32> ap_const_lv32_6;
    static const sc_lv<32> ap_const_lv32_8;
    static const sc_lv<32> ap_const_lv32_9;
    static const sc_lv<32> ap_const_lv32_B;
    static const sc_lv<32> ap_const_lv32_E;
    static const sc_lv<32> ap_const_lv32_7;
    static const int C_S_AXI_DATA_WIDTH;
    static const int C_M_AXI_GMEM_USER_VALUE;
    static const int C_M_AXI_GMEM_PROT_VALUE;
    static const int C_M_AXI_GMEM_CACHE_VALUE;
    static const int C_M_AXI_DATA_WIDTH;
    static const sc_lv<32> ap_const_lv32_1;
    static const sc_lv<32> ap_const_lv32_3;
    static const sc_lv<32> ap_const_lv32_4;
    static const sc_lv<32> ap_const_lv32_F;
    static const sc_lv<40> ap_const_lv40_0;
    static const sc_lv<2> ap_const_lv2_0;
    static const sc_lv<17> ap_const_lv17_0;
    static const sc_lv<39> ap_const_lv39_0;
    static const sc_lv<8> ap_const_lv8_0;
    static const sc_lv<32> ap_const_lv32_A0;
    static const sc_lv<3> ap_const_lv3_0;
    static const sc_lv<4> ap_const_lv4_0;
    static const sc_lv<8> ap_const_lv8_FF;
    static const sc_lv<32> ap_const_lv32_10;
    static const sc_lv<32> ap_const_lv32_17;
    static const sc_lv<32> ap_const_lv32_1F;
    static const sc_lv<40> ap_const_lv40_2D0;
    static const sc_lv<2> ap_const_lv2_2;
    static const sc_lv<2> ap_const_lv2_1;
    static const sc_lv<17> ap_const_lv17_1C200;
    static const sc_lv<17> ap_const_lv17_1;
    static const sc_lv<8> ap_const_lv8_A0;
    static const sc_lv<16> ap_const_lv16_96;
    static const sc_lv<17> ap_const_lv17_A0;
    static const sc_lv<8> ap_const_lv8_1;
    static const sc_lv<16> ap_const_lv16_4D;
    static const sc_lv<14> ap_const_lv14_1D;
    // Thread declarations
    void thread_ap_var_for_const0();
    void thread_ap_var_for_const2();
    void thread_ap_var_for_const1();
    void thread_ap_var_for_const3();
    void thread_ap_var_for_const5();
    void thread_ap_var_for_const7();
    void thread_ap_var_for_const4();
    void thread_ap_var_for_const6();
    void thread_ap_var_for_const8();
    void thread_ap_clk_no_reset_();
    void thread_ap_CS_fsm_pp0_stage0();
    void thread_ap_CS_fsm_pp0_stage1();
    void thread_ap_CS_fsm_pp0_stage2();
    void thread_ap_CS_fsm_pp0_stage3();
    void thread_ap_CS_fsm_pp0_stage4();
    void thread_ap_CS_fsm_pp0_stage5();
    void thread_ap_CS_fsm_pp0_stage6();
    void thread_ap_CS_fsm_pp0_stage7();
    void thread_ap_CS_fsm_state1();
    void thread_ap_CS_fsm_state2();
    void thread_ap_CS_fsm_state36();
    void thread_ap_CS_fsm_state4();
    void thread_ap_CS_fsm_state5();
    void thread_ap_CS_fsm_state7();
    void thread_ap_block_pp0_stage0();
    void thread_ap_block_pp0_stage0_11001();
    void thread_ap_block_pp0_stage0_subdone();
    void thread_ap_block_pp0_stage1();
    void thread_ap_block_pp0_stage1_11001();
    void thread_ap_block_pp0_stage1_subdone();
    void thread_ap_block_pp0_stage2();
    void thread_ap_block_pp0_stage2_11001();
    void thread_ap_block_pp0_stage2_subdone();
    void thread_ap_block_pp0_stage3();
    void thread_ap_block_pp0_stage3_11001();
    void thread_ap_block_pp0_stage3_subdone();
    void thread_ap_block_pp0_stage4();
    void thread_ap_block_pp0_stage4_11001();
    void thread_ap_block_pp0_stage4_subdone();
    void thread_ap_block_pp0_stage5();
    void thread_ap_block_pp0_stage5_01001();
    void thread_ap_block_pp0_stage5_11001();
    void thread_ap_block_pp0_stage5_subdone();
    void thread_ap_block_pp0_stage6();
    void thread_ap_block_pp0_stage6_01001();
    void thread_ap_block_pp0_stage6_11001();
    void thread_ap_block_pp0_stage6_subdone();
    void thread_ap_block_pp0_stage7();
    void thread_ap_block_pp0_stage7_11001();
    void thread_ap_block_pp0_stage7_subdone();
    void thread_ap_block_state10_pp0_stage2_iter0();
    void thread_ap_block_state11_pp0_stage3_iter0();
    void thread_ap_block_state12_pp0_stage4_iter0();
    void thread_ap_block_state13_pp0_stage5_iter0();
    void thread_ap_block_state14_pp0_stage6_iter0();
    void thread_ap_block_state15_pp0_stage7_iter0();
    void thread_ap_block_state16_pp0_stage0_iter1();
    void thread_ap_block_state17_pp0_stage1_iter1();
    void thread_ap_block_state18_pp0_stage2_iter1();
    void thread_ap_block_state19_pp0_stage3_iter1();
    void thread_ap_block_state20_pp0_stage4_iter1();
    void thread_ap_block_state21_pp0_stage5_iter1();
    void thread_ap_block_state22_pp0_stage6_iter1();
    void thread_ap_block_state23_pp0_stage7_iter1();
    void thread_ap_block_state24_pp0_stage0_iter2();
    void thread_ap_block_state25_pp0_stage1_iter2();
    void thread_ap_block_state26_pp0_stage2_iter2();
    void thread_ap_block_state27_pp0_stage3_iter2();
    void thread_ap_block_state28_pp0_stage4_iter2();
    void thread_ap_block_state29_io();
    void thread_ap_block_state29_pp0_stage5_iter2();
    void thread_ap_block_state30_io();
    void thread_ap_block_state30_pp0_stage6_iter2();
    void thread_ap_block_state31_pp0_stage7_iter2();
    void thread_ap_block_state32_pp0_stage0_iter3();
    void thread_ap_block_state33_pp0_stage1_iter3();
    void thread_ap_block_state34_pp0_stage2_iter3();
    void thread_ap_block_state35_pp0_stage3_iter3();
    void thread_ap_block_state7();
    void thread_ap_block_state8_pp0_stage0_iter0();
    void thread_ap_block_state9_pp0_stage1_iter0();
    void thread_ap_condition_1290();
    void thread_ap_condition_1293();
    void thread_ap_condition_1297();
    void thread_ap_condition_pp0_exit_iter0_state8();
    void thread_ap_done();
    void thread_ap_enable_pp0();
    void thread_ap_idle();
    void thread_ap_idle_pp0();
    void thread_ap_phi_mux_blk_idx_phi_fu_286_p4();
    void thread_ap_phi_mux_indvar_flatten_phi_fu_241_p4();
    void thread_ap_phi_mux_is_first_line_1_phi_fu_273_p4();
    void thread_ap_phi_mux_p_1_rec_phi_fu_253_p4();
    void thread_ap_phi_mux_pix_0_1_phi_fu_263_p4();
    void thread_ap_phi_mux_pix_0_3_phi_fu_296_p4();
    void thread_ap_phi_reg_pp0_iter0_pix_0_3_reg_293();
    void thread_ap_predicate_op99_read_state8();
    void thread_ap_ready();
    void thread_ap_rst_n_inv();
    void thread_ap_sig_ioackin_gmem_AWREADY();
    void thread_ap_sig_ioackin_gmem_WREADY();
    void thread_blk_7_fu_718_p9();
    void thread_blk_idx_1_fu_460_p3();
    void thread_blk_idx_op_fu_454_p2();
    void thread_exitcond_flatten_fu_383_p2();
    void thread_exitcond_fu_367_p2();
    void thread_fb_out2_sum3_cast_fu_730_p1();
    void thread_fb_out2_sum3_fu_695_p2();
    void thread_gmem_AWADDR();
    void thread_gmem_AWVALID();
    void thread_gmem_BREADY();
    void thread_gmem_WVALID();
    void thread_gmem_blk_n_AW();
    void thread_gmem_blk_n_B();
    void thread_gmem_blk_n_W();
    void thread_grp_fu_308_p4();
    void thread_grp_fu_355_p0();
    void thread_grp_fu_355_p00();
    void thread_grp_fu_355_p1();
    void thread_grp_fu_448_ce();
    void thread_grp_fu_448_p1();
    void thread_grp_fu_485_ce();
    void thread_grp_fu_485_p1();
    void thread_grp_fu_751_p0();
    void thread_grp_fu_751_p1();
    void thread_grp_fu_751_p10();
    void thread_grp_fu_758_p0();
    void thread_grp_fu_758_p1();
    void thread_grp_fu_758_p10();
    void thread_grp_fu_766_p0();
    void thread_grp_fu_766_p1();
    void thread_grp_fu_766_p10();
    void thread_grp_fu_773_p0();
    void thread_grp_fu_773_p1();
    void thread_grp_fu_773_p10();
    void thread_grp_fu_781_p0();
    void thread_grp_fu_781_p1();
    void thread_grp_fu_781_p10();
    void thread_grp_fu_788_p0();
    void thread_grp_fu_788_p1();
    void thread_grp_fu_788_p10();
    void thread_grp_fu_796_p0();
    void thread_grp_fu_796_p1();
    void thread_grp_fu_796_p10();
    void thread_grp_fu_803_p0();
    void thread_grp_fu_803_p1();
    void thread_grp_fu_803_p10();
    void thread_grp_fu_811_p0();
    void thread_grp_fu_811_p1();
    void thread_grp_fu_811_p10();
    void thread_grp_fu_818_p0();
    void thread_grp_fu_818_p1();
    void thread_grp_fu_818_p10();
    void thread_grp_fu_826_p0();
    void thread_grp_fu_826_p1();
    void thread_grp_fu_826_p10();
    void thread_grp_fu_833_p0();
    void thread_grp_fu_833_p1();
    void thread_grp_fu_833_p10();
    void thread_grp_fu_841_p0();
    void thread_grp_fu_841_p1();
    void thread_grp_fu_841_p10();
    void thread_grp_fu_848_p0();
    void thread_grp_fu_848_p1();
    void thread_grp_fu_848_p10();
    void thread_grp_fu_856_p0();
    void thread_grp_fu_856_p1();
    void thread_grp_fu_856_p10();
    void thread_grp_fu_863_p0();
    void thread_grp_fu_863_p1();
    void thread_grp_fu_863_p10();
    void thread_i_1_fu_373_p2();
    void thread_indvar_flatten_next_fu_389_p2();
    void thread_p_1_rec1_fu_746_p2();
    void thread_p_rec_dup4_fu_401_p2();
    void thread_tmp_15_mid2_v_fu_673_p2();
    void thread_tmp_15_mid2_v_v_fu_670_p1();
    void thread_tmp_15_mid2_v_v_v_fu_406_p3();
    void thread_tmp_16_fu_414_p1();
    void thread_tmp_17_fu_471_p1();
    void thread_tmp_18_fu_506_p1();
    void thread_tmp_19_fu_536_p1();
    void thread_tmp_1_cast1_fu_364_p1();
    void thread_tmp_1_nbreadreq_fu_160_p9();
    void thread_tmp_20_fu_566_p1();
    void thread_tmp_21_fu_596_p1();
    void thread_tmp_22_fu_626_p1();
    void thread_tmp_23_fu_656_p1();
    void thread_tmp_25_fu_712_p2();
    void thread_tmp_27_fu_740_p2();
    void thread_tmp_3_cast_fu_361_p1();
    void thread_tmp_7_fu_395_p2();
    void thread_tmp_8_1_fu_479_p1();
    void thread_tmp_8_1_fu_479_p10();
    void thread_tmp_8_1_fu_479_p2();
    void thread_tmp_8_2_fu_514_p1();
    void thread_tmp_8_2_fu_514_p10();
    void thread_tmp_8_2_fu_514_p2();
    void thread_tmp_8_3_fu_544_p1();
    void thread_tmp_8_3_fu_544_p10();
    void thread_tmp_8_3_fu_544_p2();
    void thread_tmp_8_4_fu_574_p1();
    void thread_tmp_8_4_fu_574_p10();
    void thread_tmp_8_4_fu_574_p2();
    void thread_tmp_8_5_fu_604_p1();
    void thread_tmp_8_5_fu_604_p10();
    void thread_tmp_8_5_fu_604_p2();
    void thread_tmp_8_6_fu_634_p1();
    void thread_tmp_8_6_fu_634_p10();
    void thread_tmp_8_6_fu_634_p2();
    void thread_tmp_8_7_fu_664_p1();
    void thread_tmp_8_7_fu_664_p10();
    void thread_tmp_8_7_fu_664_p2();
    void thread_tmp_8_fu_442_p1();
    void thread_tmp_8_fu_442_p10();
    void thread_tmp_8_fu_442_p2();
    void thread_tmp_9_cast_fu_418_p4();
    void thread_tmp_user_V_fu_379_p1();
    void thread_video_in_TDATA_blk_n();
    void thread_video_in_TREADY();
    void thread_ap_NS_fsm();
    void thread_hdltv_gen();
};

}

using namespace ap_rtl;

#endif
